# coding: cp932
# f[^HEE̓Cu
import numpy as np
import pandas as pd
# Cu
import matplotlib.pyplot as plt
# @BwKCu
import sklearn
from sklearn.decomposition import PCA
from sklearn.preprocessing import StandardScaler
# f[^ǂݍނ߂̃C|[g
from sklearn.datasets import load_breast_cancer
# f[^̎擾
cancer = load_breast_cancer()
# f[^malignantijbenigniǐjɕ邽߂̃tB^[
# malignantijcancer.target0
malignant = cancer.data[cancer.target==0]
# benigniǐjcancer.target0
benign = cancer.data[cancer.target==1]
# malignantiju[AbenigniǐjIW̃qXgO
# e}́AeX̐ϐimean radiusȂǁjƖړIϐƂ̊֌WqXgO
fig, axes = plt.subplots(5,4,figsize=(20,20))
ax = axes.ravel()
for i in range(20):
    _,bins = np.histogram(cancer.data[:,i], bins=50)
    ax[i].hist(malignant[:,i], bins, alpha=.5)
    ax[i].hist(benign[:,i], bins, alpha=.5)
    ax[i].set_title(cancer.feature_names[i])
    ax[i].set_yticks(())
    
# x̐ݒ
ax[0].set_ylabel('Count')
ax[0].legend(['malignant','benign'],loc='best')
fig.tight_layout()
plt.subplots_adjust( bottom=0.1, top=0.95,wspace=0.4, hspace=0.6)
plt.show()
# W
sc = StandardScaler()
X_std = sc.fit_transform(cancer.data)
# 听
pca = PCA(n_components=2)
pca.fit(X_std)
X_pca = pca.transform(X_std)
# \
print('X_pca shape:{}'.format(X_pca.shape))
print('Explained variance ratio:{}'.format(pca.explained_variance_ratio_))
# ɃxA1ڂ1听A2ڂ2听
X_pca = pd.DataFrame(X_pca, columns=['pc1','pc2'])
# ̃f[^ɁAړIϐicancer.targetjRÂAɌ
X_pca = pd.concat([X_pca, pd.DataFrame(cancer.target, columns=['target'])], axis=1)
# Aǐ𕪂
pca_malignant = X_pca[X_pca['target']==0]
pca_benign = X_pca[X_pca['target']==1]
# vbg
ax = pca_malignant.plot.scatter(x='pc1', y='pc2', color='red', label='malignant');
# ǐvbg
pca_benign.plot.scatter(x='pc1', y='pc2', color='blue', label='benign', ax=ax);
plt.show()
